Merge tag 'arm64-upstream' of git://git.kernel.org/pub/scm/linux/kernel/git/arm64...
[deliverable/linux.git] / scripts / kconfig / Makefile
1 # ===========================================================================
2 # Kernel configuration targets
3 # These targets are used from top-level makefile
4
5 PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
6 localmodconfig localyesconfig
7
8 ifdef KBUILD_KCONFIG
9 Kconfig := $(KBUILD_KCONFIG)
10 else
11 Kconfig := Kconfig
12 endif
13
14 ifeq ($(quiet),silent_)
15 silent := -s
16 endif
17
18 # We need this, in case the user has it in its environment
19 unexport CONFIG_
20
21 xconfig: $(obj)/qconf
22 $< $(silent) $(Kconfig)
23
24 gconfig: $(obj)/gconf
25 $< $(silent) $(Kconfig)
26
27 menuconfig: $(obj)/mconf
28 $< $(silent) $(Kconfig)
29
30 config: $(obj)/conf
31 $< $(silent) --oldaskconfig $(Kconfig)
32
33 nconfig: $(obj)/nconf
34 $< $(silent) $(Kconfig)
35
36 silentoldconfig: $(obj)/conf
37 $(Q)mkdir -p include/config include/generated
38 $< $(silent) --$@ $(Kconfig)
39
40 localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
41 $(Q)mkdir -p include/config include/generated
42 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
43 $(Q)if [ -f .config ]; then \
44 cmp -s .tmp.config .config || \
45 (mv -f .config .config.old.1; \
46 mv -f .tmp.config .config; \
47 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
48 mv -f .config.old.1 .config.old) \
49 else \
50 mv -f .tmp.config .config; \
51 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
52 fi
53 $(Q)rm -f .tmp.config
54
55 # Create new linux.pot file
56 # Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
57 update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
58 $(Q)$(kecho) " GEN config.pot"
59 $(Q)xgettext --default-domain=linux \
60 --add-comments --keyword=_ --keyword=N_ \
61 --from-code=UTF-8 \
62 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
63 --directory=$(srctree) --directory=$(objtree) \
64 --output $(obj)/config.pot
65 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
66 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
67 $(srctree)/arch/*/um/Kconfig`; \
68 do \
69 $(kecho) " GEN $$i"; \
70 $(obj)/kxgettext $$i \
71 >> $(obj)/config.pot; \
72 done )
73 $(Q)$(kecho) " GEN linux.pot"
74 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
75 --output $(obj)/linux.pot
76 $(Q)rm -f $(obj)/config.pot
77
78 # These targets map 1:1 to the commandline options of 'conf'
79 simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
80 alldefconfig randconfig listnewconfig olddefconfig
81 PHONY += $(simple-targets)
82
83 $(simple-targets): $(obj)/conf
84 $< $(silent) --$@ $(Kconfig)
85
86 PHONY += oldnoconfig savedefconfig defconfig
87
88 # oldnoconfig is an alias of olddefconfig, because people already are dependent
89 # on its behavior(sets new symbols to their default value but not 'n') with the
90 # counter-intuitive name.
91 oldnoconfig: olddefconfig
92
93 savedefconfig: $(obj)/conf
94 $< $(silent) --$@=defconfig $(Kconfig)
95
96 defconfig: $(obj)/conf
97 ifeq ($(KBUILD_DEFCONFIG),)
98 $< $(silent) --defconfig $(Kconfig)
99 else
100 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
101 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
102 endif
103
104 %_defconfig: $(obj)/conf
105 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
106
107 configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
108
109 %.config: $(obj)/conf
110 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
111 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
112 +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
113
114 PHONY += kvmconfig
115 kvmconfig: kvm_guest.config
116 @:
117
118 PHONY += tinyconfig
119 tinyconfig:
120 $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
121
122 # Help text used by make help
123 help:
124 @echo ' config - Update current config utilising a line-oriented program'
125 @echo ' nconfig - Update current config utilising a ncurses menu based program'
126 @echo ' menuconfig - Update current config utilising a menu based program'
127 @echo ' xconfig - Update current config utilising a QT based front-end'
128 @echo ' gconfig - Update current config utilising a GTK based front-end'
129 @echo ' oldconfig - Update current config utilising a provided .config as base'
130 @echo ' localmodconfig - Update current config disabling modules not loaded'
131 @echo ' localyesconfig - Update current config converting local mods to core'
132 @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
133 @echo ' defconfig - New config with default from ARCH supplied defconfig'
134 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
135 @echo ' allnoconfig - New config where all options are answered with no'
136 @echo ' allyesconfig - New config where all options are accepted with yes'
137 @echo ' allmodconfig - New config selecting modules when possible'
138 @echo ' alldefconfig - New config with all symbols set to default'
139 @echo ' randconfig - New config with random answer to all options'
140 @echo ' listnewconfig - List new options'
141 @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their default value'
142 @echo ' kvmconfig - Enable additional options for guest kernel support'
143 @echo ' tinyconfig - Configure the tiniest possible kernel'
144
145 # lxdialog stuff
146 check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
147
148 # Use recursively expanded variables so we do not call gcc unless
149 # we really need to do so. (Do not call gcc as part of make mrproper)
150 HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
151 -DLOCALE
152
153 # ===========================================================================
154 # Shared Makefile for the various kconfig executables:
155 # conf: Used for defconfig, oldconfig and related targets
156 # nconf: Used for the nconfig target.
157 # Utilizes ncurses
158 # mconf: Used for the menuconfig target
159 # Utilizes the lxdialog package
160 # qconf: Used for the xconfig target
161 # Based on QT which needs to be installed to compile it
162 # gconf: Used for the gconfig target
163 # Based on GTK which needs to be installed to compile it
164 # object files used by all kconfig flavours
165
166 lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
167 lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
168
169 conf-objs := conf.o zconf.tab.o
170 mconf-objs := mconf.o zconf.tab.o $(lxdialog)
171 nconf-objs := nconf.o zconf.tab.o nconf.gui.o
172 kxgettext-objs := kxgettext.o zconf.tab.o
173 qconf-cxxobjs := qconf.o
174 qconf-objs := zconf.tab.o
175 gconf-objs := gconf.o zconf.tab.o
176
177 hostprogs-y := conf nconf mconf kxgettext qconf gconf
178
179 clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
180 clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
181 clean-files += config.pot linux.pot
182
183 # Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
184 PHONY += $(obj)/dochecklxdialog
185 $(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
186 $(obj)/dochecklxdialog:
187 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
188
189 always := dochecklxdialog
190
191 # Add environment specific flags
192 HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
193
194 # generated files seem to need this to find local include files
195 HOSTCFLAGS_zconf.lex.o := -I$(src)
196 HOSTCFLAGS_zconf.tab.o := -I$(src)
197
198 LEX_PREFIX_zconf := zconf
199 YACC_PREFIX_zconf := zconf
200
201 HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
202 HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
203
204 HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
205 HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
206 -Wno-missing-prototypes
207
208 HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
209
210 HOSTLOADLIBES_nconf = $(shell \
211 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
212 || pkg-config --libs menu panel ncurses 2>/dev/null \
213 || echo "-lmenu -lpanel -lncurses" )
214 $(obj)/qconf.o: $(obj)/.tmp_qtcheck
215
216 ifeq ($(MAKECMDGOALS),xconfig)
217 $(obj)/.tmp_qtcheck: $(src)/Makefile
218 -include $(obj)/.tmp_qtcheck
219
220 # QT needs some extra effort...
221 $(obj)/.tmp_qtcheck:
222 @set -e; $(kecho) " CHECK qt"; dir=""; pkg=""; \
223 if ! pkg-config --exists QtCore 2> /dev/null; then \
224 echo "* Unable to find the QT4 tool qmake. Trying to use QT3"; \
225 pkg-config --exists qt 2> /dev/null && pkg=qt; \
226 pkg-config --exists qt-mt 2> /dev/null && pkg=qt-mt; \
227 if [ -n "$$pkg" ]; then \
228 cflags="\$$(shell pkg-config $$pkg --cflags)"; \
229 libs="\$$(shell pkg-config $$pkg --libs)"; \
230 moc="\$$(shell pkg-config $$pkg --variable=prefix)/bin/moc"; \
231 dir="$$(pkg-config $$pkg --variable=prefix)"; \
232 else \
233 for d in $$QTDIR /usr/share/qt* /usr/lib/qt*; do \
234 if [ -f $$d/include/qconfig.h ]; then dir=$$d; break; fi; \
235 done; \
236 if [ -z "$$dir" ]; then \
237 echo >&2 "*"; \
238 echo >&2 "* Unable to find any QT installation. Please make sure that"; \
239 echo >&2 "* the QT4 or QT3 development package is correctly installed and"; \
240 echo >&2 "* either qmake can be found or install pkg-config or set"; \
241 echo >&2 "* the QTDIR environment variable to the correct location."; \
242 echo >&2 "*"; \
243 false; \
244 fi; \
245 libpath=$$dir/lib; lib=qt; osdir=""; \
246 $(HOSTCXX) -print-multi-os-directory > /dev/null 2>&1 && \
247 osdir=x$$($(HOSTCXX) -print-multi-os-directory); \
248 test -d $$libpath/$$osdir && libpath=$$libpath/$$osdir; \
249 test -f $$libpath/libqt-mt.so && lib=qt-mt; \
250 cflags="-I$$dir/include"; \
251 libs="-L$$libpath -Wl,-rpath,$$libpath -l$$lib"; \
252 moc="$$dir/bin/moc"; \
253 fi; \
254 if [ ! -x $$dir/bin/moc -a -x /usr/bin/moc ]; then \
255 echo "*"; \
256 echo "* Unable to find $$dir/bin/moc, using /usr/bin/moc instead."; \
257 echo "*"; \
258 moc="/usr/bin/moc"; \
259 fi; \
260 else \
261 cflags="\$$(shell pkg-config QtCore QtGui Qt3Support --cflags)"; \
262 libs="\$$(shell pkg-config QtCore QtGui Qt3Support --libs)"; \
263 moc="\$$(shell pkg-config QtCore --variable=moc_location)"; \
264 [ -n "$$moc" ] || moc="\$$(shell pkg-config QtCore --variable=prefix)/bin/moc"; \
265 fi; \
266 echo "KC_QT_CFLAGS=$$cflags" > $@; \
267 echo "KC_QT_LIBS=$$libs" >> $@; \
268 echo "KC_QT_MOC=$$moc" >> $@
269 endif
270
271 $(obj)/gconf.o: $(obj)/.tmp_gtkcheck
272
273 ifeq ($(MAKECMDGOALS),gconfig)
274 -include $(obj)/.tmp_gtkcheck
275
276 # GTK needs some extra effort, too...
277 $(obj)/.tmp_gtkcheck:
278 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
279 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
280 touch $@; \
281 else \
282 echo >&2 "*"; \
283 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
284 echo >&2 "*"; \
285 false; \
286 fi \
287 else \
288 echo >&2 "*"; \
289 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
290 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
291 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
292 echo >&2 "*"; \
293 false; \
294 fi
295 endif
296
297 $(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
298
299 $(obj)/qconf.o: $(obj)/qconf.moc
300
301 quiet_cmd_moc = MOC $@
302 cmd_moc = $(KC_QT_MOC) -i $< -o $@
303
304 $(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
305 $(call cmd,moc)
306
307 # Extract gconf menu items for I18N support
308 $(obj)/gconf.glade.h: $(obj)/gconf.glade
309 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
310 $(obj)/gconf.glade
This page took 0.038322 seconds and 5 git commands to generate.